#define _CRT_SECURE_NO_DEPRECATE
#define RPC_NO_WINDOWS_H
#define NONAMELESSUNION

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <commctrl.h>

#pragma warning(disable: 344 1111)	/* for the "typedef... DWORD/BYTE" */
#include "metaxpon.h"
#pragma warning(default: 344 1111)

#pragma comment(lib, "comctl32")
#pragma comment(lib, "comdlg32")
#pragma comment(lib, "shell32")
#pragma comment(lib, "user32")
#pragma comment(lib, "winmm")

#define IDC_OPEN	3000
#define IDC_INFO	3001
#define IDC_FILE	3010
#define IDC_TEMPO	3011
#define IDC_CPU 	3012
#define IDC_indicator	3013
#define IDC_FAST	3014
#define IDC_PRO 	3015
#define IDC_TRACKBAR	3020
#define IDI_ICON	3025
#define IDD_DIALOG	3030
#define WM_CPU		(WM_USER + 0x100)
#define WM_INDICATOR	(WM_USER + 0x101)

/* Wave header constants */
#define RIFF_ID 	0x46464952	/* 'FFIR' => 'RIFF' */
#define WAVE_ID 	0x45564157	/* 'EVAW' => 'WAVE' */
#define FMT		0x20746D66	/* ' tmf' => 'fmt ' */
#define DATA		0x61746164	/* 'atad' => 'data' */
#define PCM_CODE	1
#define WAVE_MONO	1
#define WAVE_STEREO	2

/* Buffer sizes, etc. */
#define INBLOCKSAM	16384
#define OUTBLOCKSAM	4096
#define SAMPLESIZE	4
#define INBLOCK 	(SAMPLESIZE * INBLOCKSAM)
#define OUTBLOCK	(SAMPLESIZE * OUTBLOCKSAM)
#define HOPSIZE 	1024
#define nOutBlocks	3

unsigned short METAXPON[] = {'M',0x3B5,0x3C4,0x3B1,0x2573,0x2119,0x25CE,0x2115,0};
#ifdef ENGLISH
  char InfoCaption[]	= "METAXPON Demo Player Information";
  char Info[]		= "Fast Algorithm - higher processing speed, good for high stretching factors (lower tempos).\r"
			  "PRO Algorithm - better time resolution, transient detection and transient processing.\r\r"
			  "Only uncompressed, 16-bit, stereo .WAV files are supported.";
  char FilterString[]	= "WAVE files (*.WAV)\x0*.WAV\x0"
			  "All files (*.*)\x0*.*\x0";
#else
  char InfoCaption[]	= "  METAXPON";
  char Info[]		= "  - -   ,   -    ( ).\r"
			  "  - -    ,     .\r\r"
			  "    16-  .WAV-.";
  char FilterString[]	= "WAVE- (*.WAV)\x0*.WAV\x0"
			  "  (*.*)\x0*.*\x0";
#endif

struct {
	DWORD chunkID;		/* "fmt " */
	DWORD sc_len;		/* length of sub_chunk, =16 */
	 WORD format;		/* should be 1 for PCM-code */
	 WORD modus;		/* 1 Mono, 2 Stereo */
	DWORD sample_fq;	/* frequency of sample */
	DWORD byte_p_sec;
	 WORD byte_p_spl;	/* sample_size, 1 - 16 bytes */
	 WORD bit_p_spl;	/* bits per sample 8, 12, 16, 24, 32 bit */
} Head;
struct MXdata vb;
LARGE_INTEGER performanceFrequency;

CRITICAL_SECTION C_S;
DWORD count, TBPos, Rdy;
int Remain;
BOOL fStop, algo;

HANDLE hEventRdy, hFileI, hDlg, hPlay;
HINSTANCE hInstance;

int __cdecl MXinitPro(struct MXdata *);
int __cdecl MXstartPro(struct MXdata *);
int __cdecl MXprocessPro(struct MXdata *);

static void SelectAlgo(BOOL alg)
{
	BYTE *p = (BYTE *)&vb.Internal[9 + 4 * sizeof(void *)] + 1;	/* OutBlkHops */

	EnterCriticalSection(&C_S);
	algo = alg;
	vb.Version = METAXPON_VERSION;
	if (!alg) {
		*p = OUTBLOCKSAM / HOPSIZE;
		MXinit(&vb);
	} else {
		*p = 2 * OUTBLOCKSAM / HOPSIZE;
		MXinitPro(&vb);
	}
	LeaveCriticalSection(&C_S);
}

static DWORD FindData(HANDLE f)
{
	DWORD ptr = 0, len = 0;
	BOOL valid = FALSE;

	if (!ReadFile(f, &Head, 12, &count, NULL) || count != 12 || Head.chunkID != RIFF_ID || (Head.format | Head.modus << 16) != WAVE_ID)
		return 0;
	for ( ; ; ) {
		if (!ReadFile(f, &Head, 8, &count, NULL) || count != 8)
			return 0;
		if (Head.chunkID == DATA) {
			ptr = SetFilePointer(f, 0, NULL, FILE_CURRENT);
			len = Head.sc_len;
		} else if (Head.chunkID == FMT) {
			if (!ReadFile(f, &Head.format, sizeof(Head) - 8, &count, NULL) || count != sizeof(Head) - 8)
				return 0;
			if (Head.format == PCM_CODE && Head.modus == WAVE_STEREO && Head.byte_p_spl == 4 && Head.bit_p_spl == 16) {
				valid = TRUE;
				Head.sc_len -= sizeof(Head) - 8;
			}
		}
		if (len && valid)
			break;
		SetFilePointer(f, Head.sc_len, NULL, FILE_CURRENT);
	}
	return SetFilePointer(f, ptr, NULL, FILE_BEGIN);
}

void CALLBACK PlaySet(HWAVEOUT hwo, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
{
	UNREFERENCED_PARAMETER(hwo);
	UNREFERENCED_PARAMETER(uMsg);
	UNREFERENCED_PARAMETER(dwInstance);
	UNREFERENCED_PARAMETER(dwParam1);
	UNREFERENCED_PARAMETER(dwParam2);

	if (Rdy < nOutBlocks)
		Rdy++;
	SetEvent(hEventRdy);
}

DWORD WINAPI Play(LPVOID Frequency)
{
	static WAVEFORMATEX wfx = {WAVE_FORMAT_PCM, WAVE_STEREO, 0, 0, SAMPLESIZE, 16, 0};
	static WAVEHDR wh[nOutBlocks];
	HWAVEOUT HWO;
	LARGE_INTEGER performanceCounter;
	DWORD timeL, timeS, timeN, flagP;
	int i, r = 0;

	wfx.nSamplesPerSec = (DWORD)Frequency;
	wfx.nAvgBytesPerSec = (DWORD)Frequency * SAMPLESIZE;
	Rdy = nOutBlocks;
	hEventRdy = CreateEventA(NULL, FALSE, FALSE, NULL);
	if (waveOutOpen(&HWO, WAVE_MAPPER, &wfx, (DWORD)PlaySet, 0, CALLBACK_FUNCTION) == MMSYSERR_NOERROR) {
		for (i = 0; i < nOutBlocks; i++) {
			wh[i].lpData = (LPSTR)vb.OutBuf + i * OUTBLOCK;
			wh[i].dwBufferLength = OUTBLOCK;
			wh[i].dwFlags = 0;
		}
		vb.Empty = 1;
		vb.Last = 0;
		vb.E0F = 0;
		vb.OutBufNum = 0;
		vb.OutBufSizeK = OUTBLOCK / 1024;
		EnterCriticalSection(&C_S);
		algo ? MXstartPro(&vb) : MXstart(&vb);
		LeaveCriticalSection(&C_S);
		waveOutReset(HWO);
		for (i = 0; i < nOutBlocks; i++)
			waveOutPrepareHeader(HWO, &wh[i], sizeof(WAVEHDR));
		Remain -= INBLOCK;
		ReadFile(hFileI, vb.InBuf, Remain < 0 ? Remain + INBLOCK : INBLOCK, &count, NULL);
		if (count < INBLOCK) {
			vb.E0F = 1;
			vb.Last = count;
			vb.Empty = 0;
		}
		timeL = timeS = timeN = flagP = 0;
		do {
			DWORD p, tick;
			LPWAVEHDR pwh;

			if (fStop)
				goto stop;
			p = timeN / 8 & 1;
			if (p && !flagP)
				flagP = p;
			else
				PostMessageA(hDlg, WM_INDICATOR, p, p);
			if (vb.Empty) {
				Remain -= INBLOCK;
				ReadFile(hFileI, (vb.Half - 1 & INBLOCK) + (BYTE *)vb.InBuf, Remain < 0 ? Remain + INBLOCK : INBLOCK, &count, NULL);
				if (count < INBLOCK) {
					vb.E0F = (BYTE)(2 - vb.Half);
					vb.Last = count;
				}
				vb.Empty = 0;
			}
			while (!Rdy)
				WaitForSingleObject(hEventRdy, INFINITE);
			Rdy--;
			vb.Tempo = (TBPos * 65536 + 50) / 100;
			QueryPerformanceCounter(&performanceCounter);
			EnterCriticalSection(&C_S);
			r = algo ? MXprocessPro(&vb) : MXprocess(&vb);
			LeaveCriticalSection(&C_S);
			tick = performanceCounter.LowPart;
			p = QueryPerformanceCounter(&performanceCounter);
			tick -= performanceCounter.LowPart;
			i = r;
			if (i) {
				if (i == -1)
					i = OUTBLOCKSAM;
				timeS += i;
				timeL -= tick;
				timeN++;
				if (timeN == 16) {
					performanceCounter.QuadPart = 1000 * timeL * (unsigned __int64)Frequency / (performanceFrequency.QuadPart * timeS);
					PostMessageA(hDlg, WM_CPU, performanceCounter.LowPart, p);
					timeL = timeS = timeN = 0;
				}
			}
			pwh = &wh[vb.OutBufNum];
			if (++vb.OutBufNum >= nOutBlocks)
				vb.OutBufNum = 0;
			if (r != -1) {
				waveOutUnprepareHeader(HWO, pwh, sizeof(WAVEHDR));
				pwh->dwBufferLength = SAMPLESIZE * r;
				waveOutPrepareHeader(HWO, pwh, sizeof(WAVEHDR));
			}
			waveOutWrite(HWO, pwh, sizeof(WAVEHDR));
		} while (r == -1);
		for (i = 0; i < nOutBlocks; i++, Rdy--)
			while (!Rdy)
				r = WaitForSingleObject(hEventRdy, INFINITE);
	stop:	PostMessageA(hDlg, WM_CPU, 0, r);
		PostMessageA(hDlg, WM_INDICATOR, 1, r = waveOutReset(HWO));
		for (i = 0; i < nOutBlocks; i++) {
			while (!(wh[0].dwFlags & WHDR_DONE))
				Sleep(0);
			waveOutUnprepareHeader(HWO, &wh[i], sizeof(WAVEHDR));
		}
		waveOutClose(HWO);
	}
	CloseHandle(hEventRdy);
	CloseHandle(hFileI);
	r = CloseHandle(hPlay);
	hPlay = INVALID_HANDLE_VALUE;
	return r;
}

BOOL CALLBACK DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HGLOBAL pMEMi = NULL, pMEMo = NULL, pMEMx = NULL;
	static HANDLE hTrackBar;
	HANDLE f;
	DWORD ThreadID;
	static char FileName[MAX_PATH];
	char *p, *q, cpu[8];

	hDlg = hWnd;
	switch (uMsg) {
		case WM_CPU:
			sprintf(cpu, "%.1f", (float)wParam / 10);
			SetDlgItemTextA(hWnd, IDC_CPU, cpu);
			return TRUE;
		case WM_INDICATOR:
			ShowWindow(GetDlgItem(hWnd, IDC_indicator), wParam ? 0 : SW_SHOW);
			return TRUE;
		case WM_INITDIALOG:
			hPlay = INVALID_HANDLE_VALUE;
			SetWindowTextW(hWnd, METAXPON);
			SetClassLongA(hWnd, GCL_HICON, (LONG)LoadIconA(hInstance, MAKEINTRESOURCEA(IDI_ICON)));
			SetWindowLongA(hWnd, GWL_EXSTYLE, WS_EX_ACCEPTFILES);
			ShowWindow(GetDlgItem(hWnd, IDC_indicator), SW_HIDE);
			InitializeCriticalSection(&C_S);
			QueryPerformanceFrequency(&performanceFrequency);
			vb.InBuf  = pMEMi = GlobalAlloc(GMEM_FIXED, INBLOCK * 2 + 32);
			vb.OutBuf = pMEMo = GlobalAlloc(GMEM_FIXED, OUTBLOCK * nOutBlocks + 32);
			vb.Memory = pMEMx = GlobalAlloc(GMEM_FIXED, INT_BUF_SIZE);
			CheckRadioButton(hWnd, IDC_FAST, IDC_PRO, IDC_FAST);
			SendMessageA(hTrackBar = GetDlgItem(hWnd, IDC_TRACKBAR), TBM_SETRANGE, TRUE, 200 * 65536 + 50);
			SendMessageA(hTrackBar, TBM_SETPAGESIZE, TRUE, 10);
			SendMessageA(hTrackBar, TBM_SETSEL, FALSE, 21 * 65536 + 1);
			SendMessageA(hTrackBar, TBM_SETPOS, TRUE, 100);
			SendMessageA(hWnd, WM_VSCROLL, SendMessageA(hTrackBar, TBM_SETTICFREQ, 10, 1), (LPARAM)hTrackBar);
			SelectAlgo(0);
			if (__argc > 1)
				strcpy(FileName, __argv[1]);
			goto search;
		case WM_VSCROLL:
			if (lParam == (LPARAM)hTrackBar) {
				SetDlgItemInt(hWnd, IDC_TEMPO, TBPos = SendMessageA(hTrackBar, TBM_GETPOS, 0, 0), FALSE);
				return TRUE;
			}
			break;
		case WM_CLOSE:
			while (hPlay != INVALID_HANDLE_VALUE) {
				fStop = TRUE;
				WaitForSingleObject(hPlay, INFINITE);
			}
			DeleteCriticalSection(&C_S);
			GlobalFree(pMEMx);
			GlobalFree(pMEMo);
			GlobalFree(pMEMi);
			EndDialog(hWnd, 0x6789);
			return TRUE;
		case WM_DROPFILES:
			DragQueryFileA((HDROP)wParam, 0, FileName, MAX_PATH);
			DragFinish((HDROP)wParam);
	search: 	p = q = FileName;
			while(*q)
				if (*q++ == '\\')
					p = q;
	start:		if ((f = CreateFileA(FileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL)) != INVALID_HANDLE_VALUE) {
				if (FindData(f)) {
					while(hPlay != INVALID_HANDLE_VALUE) {
						fStop = TRUE;
						WaitForSingleObject(hPlay, INFINITE);
					}
					SetDlgItemTextA(hWnd, IDC_FILE, p);
					fStop = FALSE;
					Remain = Head.sc_len;
					hFileI = f;
					SetThreadPriority(hPlay = CreateThread(NULL, 0, Play, (LPVOID)Head.sample_fq, 0, &ThreadID), THREAD_PRIORITY_HIGHEST);
				} else
					CloseHandle(f);
			}
			return TRUE;
		case WM_COMMAND:
			if (lParam) {
				switch(wParam) {
					case BN_CLICKED * 65536 + IDC_OPEN:
						{
							static OPENFILENAME ofn = {
								sizeof(ofn), 0, 0, FilterString, 0, 0, 1, FileName, MAX_PATH, 0, 0, 0, 0,
								OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_LONGNAMES | OFN_EXPLORER | OFN_HIDEREADONLY,
								0, 0, FilterString + sizeof(FilterString) - 4, 0, 0, 0
							};
							BOOL r;

							ofn.hwndOwner = hWnd;
							ofn.hInstance = hInstance;
							r = GetOpenFileNameA(&ofn);
							p = FileName + ofn.nFileOffset;
							if (r)
								goto start;
							break;
						}
					case BN_CLICKED * 65536 + IDC_FAST:
						SelectAlgo(0);
						break;
					case BN_CLICKED * 65536 + IDC_PRO:
						SelectAlgo(1);
						break;
					case BN_CLICKED * 65536 + IDC_INFO:
						MessageBoxA(hWnd, Info, InfoCaption, MB_OK);
				}
			}
	}
	return FALSE;
}

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	UNREFERENCED_PARAMETER(hInst);
	UNREFERENCED_PARAMETER(hPrevInst);
	UNREFERENCED_PARAMETER(lpCmdLine);
	UNREFERENCED_PARAMETER(nCmdShow);

	InitCommonControls();
	if (DialogBoxParamW(hInstance = GetModuleHandleA(NULL), MAKEINTRESOURCEW(IDD_DIALOG), NULL, DlgProc, 0) != 0x6789)
		DialogBoxParamA(hInstance, MAKEINTRESOURCEA(IDD_DIALOG), NULL, DlgProc, 0);
	ExitProcess(0);
}
