.486
.model flat,stdcall
option casemap:none

include windows.inc
include smacros.inc
includelib kernel32.lib
includelib user32.lib
includelib comctl32.lib
includelib shell32.lib
includelib comdlg32.lib
includelib winmm.lib

externdef MXinit: proc
externdef MXinitPro: proc
externdef MXstart: proc
externdef MXstartPro: proc
externdef MXprocess: proc
externdef MXprocessPro: proc


.const

IDC_OPEN	=	3000
IDC_INFO	=	3001
IDC_FILE	=	3010
IDC_TEMPO	=	3011
IDC_CPU 	=	3012
IDC_indicator	=	3013
IDC_FAST	=	3014
IDC_PRO 	=	3015
IDC_TRACKBAR	=	3020
IDI_ICON	=	3025
IDD_DIALOG	=	3030
WM_CPU		=	WM_USER+100h
WM_INDICATOR	=	WM_USER+101h

thousand	dw	1000
METAXPON	dw	'M',3B5h,3C4h,3B1h,2573h,2119h,25CEh,2115h,0
ifdef ENGLISH
  InfoCaption	db	"METAXPON Demo Player Information",0
  Info		db	"Fast Algorithm - higher processing speed, good for high stretching factors (lower tempos).",13
		db	"PRO Algorithm - better time resolution, transient detection and transient processing.",13,13
		db	"Only uncompressed, 16-bit, stereo .WAV files are supported.",0
FilterString	db	"WAVE files (*.WAV)",0,"*.WAV",0
		db	"All files (*.*)",0,"*.*",0,0
else
  InfoCaption	db	"  METAXPON",0
  Info		db	"  - -   ,   -    ( ).",13
		db	"  - -    ,     .",13,13
		db	"    16-  .WAV-.",0
FilterString	db	"WAVE- (*.WAV)",0,"*.WAV",0
		db	"  (*.*)",0,"*.*",0,0
endif

.data?

WaveHead	struct

  chunkID	DWORD	?	; "fmt "
  sc_len	DWORD	?	; length of sub_chunk, =16
  format	 WORD	?	; should be 1 for PCM-code
  modus 	 WORD	?	; 1 Mono, 2 Stereo
  sample_fq	DWORD	?	; frequency of sample
  byte_p_sec	DWORD	?	;
  byte_p_spl	 WORD	?	; sample_size, 1 - 16 bytes
  bit_p_spl	 WORD	?	; bits per sample 8, 12, 16, 24, 32 bit

WaveHead	 ends

; Wave header constants
;
RIFF_ID 	= 46464952h	; 'FFIR' => 'RIFF'
WAVE_ID 	= 45564157h	; 'EVAW' => 'WAVE'
FMT		= 20746D66h	; ' tmf' => 'fmt '
DATA		= 61746164h	; 'atad' => 'data'
PCM_CODE	= 1
WAVE_MONO	= 1
WAVE_STEREO	= 2

include ..\VOCBUFP.INC

; Buffer sizes
;
INBLOCKSAM	 =	16384
OUTBLOCKSAM	 =	4096
INBLOCK		 =	SAMPLESIZE*INBLOCKSAM
OUTBLOCK	 =	SAMPLESIZE*OUTBLOCKSAM

nOutBlocks	=	3

Head		WaveHead	<>

align 16
vb		VB	<>

align qword
performanceFrequency	qword	?
performanceCounter	qword	?

C_S	CRITICAL_SECTION	<>

wfx	WAVEFORMATEX	<>
wh0	WAVEHDR 	<>
wh1	WAVEHDR 	<>
wh2	WAVEHDR 	<>

align dword
pMEMi		dword	?
pMEMo		dword	?
pMEMx		dword	?

count		dword	?
Remain		dword	?

HWO		HANDLE	?
hEventRdy	HANDLE	?

hFileI		HANDLE	?
hInstance	HINSTANCE ?
hDlg		HANDLE	?
hTrackBar	HANDLE	?
hPlay		HANDLE	?
TBPos		dword	?
ThreadID	dword	?
FileName	byte	MAX_PATH dup (?)

Rdy		byte	?
fStop		byte	?
algo		byte	?


.code

Begin:	summon	InitCommonControls
	mov	FileName,NULL
	summon	GetModuleHandleA, NULL
	mov	hInstance,eax
	summon	DialogBoxParamW, eax,IDD_DIALOG,NULL,offset DlgProc,NULL
	.if eax != 6789h
		summon	DialogBoxParamA, hInstance,IDD_DIALOG,NULL,offset DlgProc,NULL
	.endif
	summon	ExitProcess, 0

DlgProc proc	uses ebx esi edi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	mov	eax,hWnd
	mov	hDlg,eax
	mov	eax,uMsg

	cmp	eax,WM_CPU
	jne	@F

	sub	esp,10h
	mov	edi,esp
	mov	esi,10
	xor	ecx,ecx
	mov	eax,wParam
	.repeat
		xor	edx,edx
		div	esi
		push	edx
		inc	ecx
	.until !eax
	.repeat
		pop	eax
		or	al,'0'
		stosb
	.untilcxz
	dec	edi
	xor	ecx,ecx
	mov	cl,'.'
	mov	ch,[edi]
	.if edi==esp
		mov	al,'0'
		stosb
	.endif
	mov	[edi],ecx

	summon	SetDlgItemTextA ,hWnd,IDC_CPU,esp
	add	esp,10h
	jmp	exit

@@:	cmp	eax,WM_INDICATOR
	jne	@F

	summon	GetDlgItem, hWnd,IDC_indicator
	cmp	wParam,1
	sbb	ecx,ecx
	and	ecx,SW_SHOW
	summon	ShowWindow, eax,ecx
	jmp	exit

@@:	cmp	eax,WM_INITDIALOG
	jne	@F

	mov	hPlay,INVALID_HANDLE_VALUE
	summon	SetWindowTextW, hWnd,offset METAXPON
	summon	LoadIconA, hInstance,IDI_ICON
	summon	SetClassLongA, hWnd,GCL_HICON,eax
	summon	SetWindowLongA, hWnd,GWL_EXSTYLE,WS_EX_ACCEPTFILES
	summon	GetDlgItem, hWnd,IDC_indicator
	summon	ShowWindow ,eax,SW_HIDE
	summon	InitializeCriticalSection, offset C_S
	summon	QueryPerformanceFrequency, offset performanceFrequency

	summon	GlobalAlloc, GMEM_FIXED,INBLOCK*2+15
	mov	pMEMi,eax
	mov	vb.InBuff,eax
	summon	GlobalAlloc, GMEM_FIXED,OUTBLOCK*nOutBlocks+15
	mov	pMEMo,eax
	mov	vb.OutBuff,eax
	summon	GlobalAlloc, GMEM_FIXED,MEMBLOCK
	mov	pMEMx,eax
	mov	vb.Comp,eax

	summon	CheckRadioButton, hWnd,IDC_FAST,IDC_PRO,IDC_FAST

	summon	GetDlgItem, hWnd,IDC_TRACKBAR
	mov	hTrackBar,eax

	summon	SendMessageA,	    eax,TBM_SETRANGE,TRUE,200 shl 16 + 50
	summon	SendMessageA, hTrackBar,TBM_SETPAGESIZE,TRUE,10
	summon	SendMessageA, hTrackBar,TBM_SETSEL,FALSE,21 shl 16 +1
	summon	SendMessageA, hTrackBar,TBM_SETPOS,TRUE,100
	summon	SendMessageA, hTrackBar,TBM_SETTICFREQ,10,1
	summon	SendMessageA, hWnd,WM_VSCROLL,eax,hTrackBar

	xor	ebx,ebx
	call	SelectAlgo

	summon	GetCommandLineA
	mov	esi,eax

	lodsb
	test	al,al
	jz	exit
	.if al=='"'
		.repeat
			lodsb
			test	al,al
			jz	exit
		.until al=='"'
	.else
		.repeat
			lodsb
			test	al,al
			jz	exit
		.until al==' ' || al==9
	.endif

	.repeat
		lodsb
		test	al,al
		jz	exit
	.until al!=' ' && al!=9

	mov	edi,offset FileName
	.if al != '"'
		dec	esi
	.endif
	.repeat
		lodsb
		stosb
		test	al,al
		jz	search
	.until al == '"'
	mov	byte ptr [edi-1],0
	jmp	search

@@:	cmp	eax,WM_VSCROLL
	jne	@F
	lea	esi,lParam
	mov	edi,offset hTrackBar
	cmpsd
	jne	@F

	summon	SendMessageA, hTrackBar,TBM_GETPOS,0,0
	mov	TBPos,eax
	summon	SetDlgItemInt ,hWnd,IDC_TEMPO,eax,FALSE
	jmp	exit

@@:	cmp	eax,WM_CLOSE
	jne	@F

	.while hPlay != INVALID_HANDLE_VALUE
		push	INFINITE
		push	hPlay
		mov	fStop,1
		partial 2,WaitForSingleObject
	.endw

	summon	DeleteCriticalSection, offset C_S
	summon	GlobalFree , pMEMx
	summon	GlobalFree , pMEMo
	summon	GlobalFree , pMEMi

	summon	EndDialog, hWnd,6789h
	jmp	exit

@@:	cmp	eax,WM_DROPFILES
	jne	@F

	summon	DragQueryFileA, wParam,0,offset FileName,MAX_PATH
	summon	DragFinish, wParam
search::mov	esi,offset FileName
	mov	ebx,esi
	.repeat
		lodsb
		.if al=='\'
			mov	ebx,esi
		.endif
	.until !al

start:: summon	CreateFileA, offset FileName,GENERIC_READ,FILE_SHARE_READ,NULL, \
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL or FILE_FLAG_SEQUENTIAL_SCAN,NULL
	.if eax != INVALID_HANDLE_VALUE
		mov	edi,eax
		call	FindData
		.if eax
			.while hPlay != INVALID_HANDLE_VALUE
				push	INFINITE
				push	hPlay
				mov	fStop,1
				partial 2,WaitForSingleObject
			.endw
			summon	SetDlgItemTextA ,hWnd,IDC_FILE,ebx
			mov	fStop,0
			mov	Remain,esi
			mov	hFileI,edi
			summon	CreateThread, NULL,NULL,offset Play,Head.sample_fq,0,offset ThreadID
			mov	hPlay,eax
			summon	SetThreadPriority, eax,THREAD_PRIORITY_HIGHEST
		.else
			summon	CloseHandle, edi
		.endif
	.endif
	jmp	exit

@@:	cmp	eax,WM_COMMAND
	jne	@F
	cmp	lParam,0
	je	@F

	mov	eax,wParam
	.if eax==BN_CLICKED shl 16 + IDC_OPEN
		xor	eax,eax
		push	eax
		push	eax
		push	eax
		push	offset FilterString + sizeof FilterString - 4
		push	eax
		push	OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST \
			or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
		push	eax
		push	eax
		push	eax
		push	eax
		push	MAX_PATH
		push	offset FileName
		push	1
		push	eax
		push	eax
		push	offset FilterString
		push	hInstance
		push	hWnd
		push	sizeof OPENFILENAME

		summon	GetOpenFileNameA, esp
		movzx	ebx,[esp].OPENFILENAME.nFileOffset
		add	ebx,offset FileName
		add	esp,sizeof OPENFILENAME

		test	eax,eax
		jnz	start

	.elseif eax==BN_CLICKED shl 16 + IDC_FAST
		xor	ebx,ebx
		call	SelectAlgo

	.elseif eax==BN_CLICKED shl 16 + IDC_PRO
		xor	ebx,ebx
		inc	ebx
		call	SelectAlgo

	.elseif eax==BN_CLICKED shl 16 + IDC_INFO
		summon	MessageBoxA, hWnd,offset Info,offset InfoCaption,MB_OK
	.endif

exit::	mov	eax,TRUE
	jmp	quit

@@:	xor	eax,eax
quit::	ret


DlgProc endp


SelectAlgo proc private

	summon	EnterCriticalSection, offset C_S
	mov	algo,bl

	mov	vb.Version,VERSION
	push	offset vb
	.if !ebx
		mov	vb.OutBlkHops,OUTBLOCKSAM/HOPSIZE
		call	MXinit
	.else
		mov	vb.OutBlkHops,2*OUTBLOCKSAM/HOPSIZE
		call	MXinitPro
	.endif
	pop	eax

	summon	LeaveCriticalSection, offset C_S
	ret

SelectAlgo endp


FindData proc	private

	xor	esi,esi
	push	esi
	push	esi

	summon	ReadFile, edi,offset Head,12,offset count,NULL
	test	eax,eax
	jz	err
	cmp	count,12
	jne	err

	cmp	Head.chunkID,RIFF_ID
	jne	err

	cmp	dword ptr Head.format,WAVE_ID
	jne	err

	.repeat
		summon	ReadFile, edi,offset Head,8,offset count,NULL
		test	eax,eax
		jz	err
		cmp	count,8
		jne	err

		.if Head.chunkID == DATA
			summon	SetFilePointer, edi,0,NULL,FILE_CURRENT
			mov	[esp+dword],eax
			mov	esi,Head.sc_len
		.elseif Head.chunkID == FMT
			summon	ReadFile, edi,offset Head+8,sizeof WaveHead-8,offset count,NULL
			test	eax,eax
			jz	err
			cmp	count,sizeof WaveHead-8
			jne	err

			.if Head.format     == PCM_CODE    && \
			    Head.modus	    == WAVE_STEREO && \
			    Head.byte_p_spl == 4	   && \
			    Head.bit_p_spl  == 16
				mov	dword ptr [esp],TRUE
				sub	Head.sc_len,sizeof WaveHead-8
			.endif
		.endif
		.break.if  esi && dword ptr [esp]
		summon	SetFilePointer, edi,Head.sc_len,NULL,FILE_CURRENT
	.until	FALSE

	pop	eax
	pop	eax
	summon	SetFilePointer, edi,eax,NULL,FILE_BEGIN
	ret

err::	add	esp,2*dword
	xor	eax,eax
	ret

FindData endp


Play	Proc	uses ebx esi edi Frequency:dword

	local	timeL: dword
	local	timeS: dword
	local	timeN: dword
	local	flagP: dword

	mov	wfx.wFormatTag,WAVE_FORMAT_PCM
	mov	wfx.nChannels,WAVE_STEREO
	mov	eax,Frequency
	mov	wfx.nSamplesPerSec,eax
	shl	eax,2
	mov	wfx.nAvgBytesPerSec,eax
	mov	wfx.nBlockAlign,4
	mov	wfx.wBitsPerSample,16

	mov	Rdy,nOutBlocks
	summon	CreateEventA, NULL,FALSE,FALSE,NULL
	mov	hEventRdy,eax

	summon	waveOutOpen, offset HWO,WAVE_MAPPER,offset wfx,offset PlaySet,NULL,CALLBACK_FUNCTION

	.if eax==MMSYSERR_NOERROR
		mov	eax,vb.OutBuff
		mov	wh0.lpData,eax
		add	eax,OUTBLOCK
		mov	wh1.lpData,eax
		add	eax,OUTBLOCK
		mov	wh2.lpData,eax

		mov	wh0.dwBufferLength,OUTBLOCK
		mov	wh1.dwBufferLength,OUTBLOCK
		mov	wh2.dwBufferLength,OUTBLOCK
		mov	wh0.dwFlags,0
		mov	wh1.dwFlags,0
		mov	wh2.dwFlags,0

		mov	vb.Empty,1
		mov	vb.Last,0
		mov	vb.E0F,0
		mov	vb.LastFilledBuf,0
		mov	vb.OutBufferSzKB,OUTBLOCK/1024

		summon	EnterCriticalSection, offset C_S
		push	offset vb
		.if !algo
			call	MXstart
		.else
			call	MXstartPro
		.endif
		pop	eax
		summon	LeaveCriticalSection, offset C_S

		summon	waveOutReset, HWO
		summon	waveOutPrepareHeader, HWO,offset wh0,size wh0
		summon	waveOutPrepareHeader, HWO,offset wh1,size wh1
		summon	waveOutPrepareHeader, HWO,offset wh2,size wh2

		mov	eax,Remain
		sub	eax,INBLOCK
		mov	Remain,eax
		sbb	edx,edx
		and	eax,edx
		add	eax,INBLOCK

		summon	ReadFile, hFileI,vb.InBuff,eax,offset count,NULL

		.if count < INBLOCK
			mov	vb.E0F,1
			mov	eax,count
			mov	vb.Last,eax
			mov	vb.Empty,0
		.endif

		xor	eax,eax
		mov	timeL,eax
		mov	timeS,eax
		mov	timeN,eax
		mov	flagP,eax
		.repeat
			cmp	fStop,0
			jne	stop

			mov	eax,timeN
			shr	eax,3
			and	eax,1
			.if eax && !flagP
				mov flagP,eax
			.else
				summon	PostMessageA, hDlg,WM_INDICATOR,eax,eax
			.endif

			.if vb.Empty
				movzx	ebx,vb.Half
				dec	ebx
				and	ebx,INBLOCK
				add	ebx,vb.InBuff

				mov	ecx,Remain
				sub	ecx,INBLOCK
				mov	Remain,ecx
				sbb	edx,edx
				and	ecx,edx
				add	ecx,INBLOCK

				summon	ReadFile, hFileI,ebx,ecx,offset count,NULL

				.if count < INBLOCK
					mov	al,2
					sub	al,vb.Half
					mov	vb.E0F,al
					mov	eax,count
					mov	vb.Last,eax
				.endif

				mov	vb.Empty,0
			.endif

			.while !Rdy
				summon	WaitForSingleObject, hEventRdy,INFINITE
			.endw
			dec	Rdy

			call	get_speed
			mov	vb.Speed,eax

			summon	QueryPerformanceCounter, offset performanceCounter

			summon	EnterCriticalSection, offset C_S

			push	offset vb
			.if !algo
				call	MXprocess
			.else
				call	MXprocessPro
			.endif
			mov	[esp],eax

			summon	LeaveCriticalSection, offset C_S

			mov	edi,dword ptr performanceCounter
			summon	QueryPerformanceCounter, offset performanceCounter
			sub	edi,dword ptr performanceCounter

			mov	ecx,[esp]
			.if ecx
				.if ecx == -1
					mov	ecx,OUTBLOCKSAM
				.endif
				add	timeS,ecx
				sub	timeL,edi
				inc	timeN
				.if timeN == 16
					fild	timeL
					fimul	Frequency
					fimul	thousand
					fild	performanceFrequency
					fimul	timeS
					fdiv
					fistp	dword ptr performanceCounter
					summon	PostMessageA, hDlg,WM_CPU,dword ptr performanceCounter,eax
					xor	eax,eax
					mov	timeL,eax
					mov	timeS,eax
					mov	timeN,eax
				.endif
			.endif

			movzx	ebx,vb.LastFilledBuf
			mov	ecx,ebx
			cmp	ebx,nOutBlocks-1
			sbb	ecx,-2
			and	ecx,nOutBlocks
			mov	byte ptr vb.LastFilledBuf,cl

			imul	ebx,size WAVEHDR
			add	ebx,offset wh0
			.if	sdword ptr [esp] != -1
				summon	waveOutUnprepareHeader, HWO,ebx,size WAVEHDR
				mov	eax,[esp]
				shl	eax,2
				mov	[ebx].WAVEHDR.dwBufferLength,eax
				summon	waveOutPrepareHeader, HWO,ebx,size WAVEHDR
			.endif
			summon	waveOutWrite, HWO,ebx,size WAVEHDR

			pop	eax
		.until eax != -1

		mov	bl,nOutBlocks
		.repeat
			.while !Rdy
				summon	WaitForSingleObject, hEventRdy,INFINITE
			.endw
			dec	Rdy
			dec	bl
		.until	!bl

	stop::	summon	PostMessageA, hDlg,WM_CPU,0,eax
		summon	waveOutReset, HWO
		summon	PostMessageA, hDlg,WM_INDICATOR,1,eax

		.while !(wh0.dwFlags & WHDR_DONE)
			summon	Sleep,0
		.endw
		summon	waveOutUnprepareHeader, HWO,offset wh0,size wh0

		.while !(wh0.dwFlags & WHDR_DONE)
			summon	Sleep,0
		.endw
		summon	waveOutUnprepareHeader, HWO,offset wh1,size wh1

		.while !(wh0.dwFlags & WHDR_DONE)
			summon	Sleep,0
		.endw
		summon	waveOutUnprepareHeader, HWO,offset wh2,size wh2

		summon	waveOutClose, HWO
	.endif

	summon	CloseHandle, hEventRdy
	summon	CloseHandle, hFileI
	summon	CloseHandle, hPlay
	mov	hPlay,INVALID_HANDLE_VALUE
	ret

Play	endp


PlaySet proc	; hwo:dword, uMsg:UINT, dwInstance:dword, dwParam1:dword, dwParam2:dword
	cmp	Rdy,nOutBlocks
	adc	Rdy,0
	summon	SetEvent, hEventRdy
	ret	5*dword
PlaySet endp


get_speed proc	C
	mov	ecx,100
	mov	eax,TBPos
	shl	eax,16
	add	eax,50
	xor	edx,edx
	div	ecx
	ret
get_speed endp

end	Begin
